package de.mutschler.rpdl;

import de.mutschler.util.*;
import de.mutschler.rpdl.fileimport.*;
import java.io.*;
import java.util.*;

/**
 * This is the commandline interface...
 */
public class RPDL
{
	static boolean suspend = true;
	static public void main(String[] args) {
		Log.setLogLevel(Log.DEBUG);
		Log.setLogFile("rpdl.log");
		RpdlBase rb = new RpdlBase();
		rb.getConfig().setLocale(Locale.GERMAN);
		String testfile = args[0];	// "S:\\Save\\DA\\src\\testinput.txt";
		Log.debug(".RPDLmain", "reading file " + testfile);
		try {
			boolean timeTest = false;
			//timeTest = true;
			//suspend=false;
			if (timeTest) {
				Log.setLogLevel(Log.ERROR);
				testtime(testfile);
				return;
			}
			FileImporter fi = new FileImporter(rb, new File(testfile));
			long starttime = System.currentTimeMillis();
			if (suspend) rb.suspend(true);
			fi.scanfile();
			if (suspend) rb.suspend(false);
			long endtime = System.currentTimeMillis();
			// display all Lists and tables of the main rpdlbase
			rb.displayAll();
			Log.warn(".main", "Time to execute:  "+ (endtime-starttime) + "ms," +
			" calcs: " + rb.getNumCalc() + "/" + (rb.getNumIgnored()+rb.getNumCalc()) + "/" + rb.getCalcTime() + "ms");
		} catch (Exception e) {
			System.err.println("General-error"+ e);
			Log.exception(e);
		}
	}
	
	private static void testtime(String file) throws Exception {
		// first load an instance of the scanner, so the static fields are initialized
		RpdlScanner rs = new RpdlScanner((java.io.Reader)null);
		for (int i=1; i<1000; i++) {
			System.gc();
			try{Thread.sleep(20);} catch(Exception e){}
			RpdlBase rb = new RpdlBase();
			FileImporter fi = new FileImporter(rb, new File(file));
			long starttime = System.currentTimeMillis();
			if (suspend) rb.suspend(true);
			fi.scanfile();
			long midtime = System.currentTimeMillis();
			if (suspend) rb.suspend(false);
			long endtime = System.currentTimeMillis();
			Log.error(".main",
				""+(endtime-starttime));
//				""+i+","+(endtime-starttime) +","+rb.getCalcTime());
//				"Time to execute: #"+(i<10?"0":"") + i+": "+ (endtime-starttime) + "ms" +
//				" calcs: " + rb.getNumCalc() + "/" + (rb.getNumIgnored()+rb.getNumCalc()) + "/" + rb.getCalcTime() + "ms");
		}
	}
}