package de.mutschler.rpdl;


/**
 * All exceptions in RPDL are derived from this class.
 */
public class RpdlException extends Exception
{
	/** Info about the location where the source came from. */
	private Origin origin = null;
	
	public RpdlException (String s) {
		super(s);
	}

	public RpdlException (String s, Origin orig) {
		this(s);
		origin = orig;
	}
	
	/** Get the Origin, if available. Returns null, if no
	 * Origin has been specified.
	 */
	public Origin getOrigin() {return origin;}
	/** Only set Origin if not previously set. */
	public void fillOrigin(Origin o) {if (origin == null) origin = o;}
	
	public String getMessage() {
		String s = super.getMessage();
		if (origin == null) return s;
		return s + ", Origin: " + origin;
	}
}