package de.mutschler.rpdl.command;

import de.mutschler.rpdl.*;
import de.mutschler.rpdl.entity.*;
import java.util.*;
import java.text.*;

public class CmdTable extends RpdlCommand implements java.io.Serializable
{
	static final long serialVersionUID = -6895512447738700160L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	/** Table return type. */
	private String ttype;
	/** Tybe name */
	private String tname;
	/** parameter type */
	private String ptype;
	/** parameter name */
	private String pname;
	/** A list of ranges */
	private List entries;
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	/** A table command.
	 * @param ttpye the basictype of the table
	 * @param tname the name of the table
	 * @param ptype the parameter type of the table
	 * @param pname the name of the parameter
	 */
	public CmdTable(String ttype, String tname, String ptype, String pname, List entries) throws RpdlException
	{
		this.ttype = ttype;
		this.tname = tname;
		this.ptype = ptype;
		this.pname = pname;
		this.entries = entries;
	}

//	public void addRange(RpdlTableRange tr) {table.addRange(tr);}

	//----------------------------------------------------------------------
	//------- Overridden methods
	//----------------------------------------------------------------------
	private transient RpdlTable table;
	/** Perform the actions when added to the main RPDL object.
	 */
	public void add(RpdlBase main) throws RpdlException
	{
		try {
			table = new RpdlTable(main, ttype, tname, ptype, pname);
			table.setOrigin(getOrigin());
			table.setEntries(entries);
			main.addTable(table);
		} catch (RpdlException re) {
			re.fillOrigin(getOrigin());	// update origin if necessary
			throw re;
		}
	}

	public String toString() {
		return "CmdTable: " + table;
	}
}