package de.mutschler.rpdl.entity;

import java.util.*;
import de.mutschler.util.LogObj;
import de.mutschler.rpdl.basicvalue.BasicValue;
import de.mutschler.rpdl.*;

/**
 * This is the superclass for all calculating abjects.
 */
public abstract class RpdlFormula extends LogObj implements java.io.Serializable
{
	static final long serialVersionUID = -7694735106016795655L;
	//----------------------------------------------------------------------
	//------- Methods
	//----------------------------------------------------------------------
	
	/**
	 * Perform a calculation, and return the result.
	 */
	public abstract BasicValue calc(RpdlBase main, RpdlObject obj) throws RpdlException;

	/**
	 * Get the type of result.
	 * @param obj The object for navigation in the Tree.
	 */
	public abstract String getResultType(RpdlBase main, Entity e) throws RpdlException;

	/**
	 * Get a list of all dependencies for this formula.
	 * This returns a Set with objects of type RpdlAttribute or RpdlObject
	 */
	public abstract Set getDependencies(RpdlBase main, RpdlObject obj) throws RpdlException;
	
	//-------------------
	// Origin handling
	private Origin origin = null;
	/** Get the origin of this command. */
	public Origin getOrigin() {return origin;}
	/** Set the origin of this command. */
	public void setOrigin(Origin o) {origin=o;}
}
