package de.mutschler.rpdl.entity;

import de.mutschler.rpdl.*;
import java.util.*;

/**
 * This class implements a type.
 */
public class RpdlType extends Entity
{
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	/** Create a new Type with the corresponding name. */
	public RpdlType(RpdlBase rbase, String s, Set types) {
		super(rbase, s, types);
	}

	//----------------------------------------------------------------------
	//------- Methods
	//----------------------------------------------------------------------
	public boolean isType(RpdlType type) {
		// I must check if this object is the same type
		String name = type.getName();
		if (name.equals(getName())) return true;
		// if not, check if it is derived from this type
		return super.isType(name);
	}

	/** Types are equal if their name is equal. */
	public boolean equals(Object o) {
		if (o instanceof RpdlType) {
			return getName().equals(((RpdlType)o).getName());
		}
		return false;
	}

	public String toString() {
		return "TYPE " + super.toString();
	}
}
